/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20140926-64 [Oct 16 2014]
 * Copyright (c) 2000 - 2014 Intel Corporation
 * 
 * Disassembly of SSDT-1.aml, Wed Sep 28 11:30:43 2016
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000143D (5181)
 *     Revision         0x02
 *     Checksum         0xA8
 *     OEM ID           "HPQOEM"
 *     OEM Table ID     "2342    "
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "ACPI"
 *     Compiler Version 0x00040000 (262144)
 */
DefinitionBlock ("SSDT-1.aml", "SSDT", 2, "HPQOEM", "2342    ", 0x00001000)
{

    /*
     * External declarations that were imported from
     * the reference file [refs.txt]
     */
    External (_GPE.MMTB, MethodObj)    // 0 Arguments
    External (_GPE.VHOV, MethodObj)    // 3 Arguments
    External (_SB_.PCI0.GFX0.DD02._BCM, MethodObj)    // 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECRD, MethodObj)    // 1 Arguments
    External (_SB_.PCI0.LPCB.H_EC.ECWT, MethodObj)    // 2 Arguments
    External (_SB_.PCI0.PEG0.PEGP.SGPO, MethodObj)    // 2 Arguments
    External (_SB_.PCI0.SAT0.SDSM, MethodObj)    // 4 Arguments
    External (_SB_.PCI0.SAT1.SDSM, MethodObj)    // 4 Arguments
    External (MDBG, MethodObj)    // 1 Arguments

    External (_PR_.DTS1, FieldUnitObj)
    External (_PR_.DTS2, FieldUnitObj)
    External (_PR_.DTS3, FieldUnitObj)
    External (_PR_.DTS4, FieldUnitObj)
    External (_PR_.PDTS, FieldUnitObj)
    External (_TZ_.TZ00._TMP, IntObj)
    External (_TZ_.TZ01, UnknownObj)
    External (_TZ_.TZ01._TMP, MethodObj)    // 0 Arguments
    External (BID_, FieldUnitObj)
    External (PAMT, FieldUnitObj)

    Scope (\_SB)
    {
        Device (PTID)
        {
            Name (_HID, EisaId ("INT340E"))  // _HID: Hardware ID
            Name (_CID, EisaId ("PNP0C02"))  // _CID: Compatible ID
            Name (IVER, 0x00030000)
            Name (_STA, 0x0F)  // _STA: Status
            Method (TSDL, 0, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                While (One)
                {
                    Store (BID, _T_0)
                    If (LEqual (_T_0, 0x38))
                    {
                        Return (TSD4)
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x30))
                        {
                            Return (TSD3)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x31))
                            {
                                Return (TSD2)
                            }
                            Else
                            {
                                If (LNotEqual (Match (Package (0x0A)
                                                {
                                                    0x80, 
                                                    0x83, 
                                                    0x82, 
                                                    0x20, 
                                                    0x22, 
                                                    0x27, 
                                                    0x28, 
                                                    0x24, 
                                                    0x30, 
                                                    0x31
                                                }, MEQ, _T_0, MTR, Zero, Zero), Ones))
                                {
                                    Return (TSD5)
                                }
                                Else
                                {
                                    Return (TSD1)
                                }
                            }
                        }
                    }

                    Break
                }
            }

            Name (TSD1, Package (0x2C)
            {
                Zero, 
                "CPU Core 0 DTS", 
                Zero, 
                "CPU Core 1 DTS", 
                Zero, 
                "CPU Core 2 DTS", 
                Zero, 
                "CPU Core 3 DTS", 
                Zero, 
                "CPU Core Package DTS", 
                0x03, 
                "CPU Core VR (IMVP) Temperature", 
                0x03, 
                "Heat Exchanger Fan Temperature", 
                0x03, 
                "Skin Temperature", 
                0x03, 
                "Ambient Temperature", 
                0x02, 
                "Sensor 5 Not used.", 
                0x02, 
                "Channel 0 DIMM Temperature", 
                0x02, 
                "Channel 1 DIMM Temperature", 
                Zero, 
                "CPU Package Temperature", 
                0x05, 
                "PCH DTS Temperature from PCH", 
                Zero, 
                "CPU PECI reading", 
                0x05, 
                "SA DTS Temperature from PCH", 
                0x02, 
                "TS-on-DIMM0 Temperature", 
                0x02, 
                "TS-on-DIMM1 Temperature", 
                0x02, 
                "TS-on-DIMM2 Temperature", 
                0x02, 
                "TS-on-DIMM3 Temperature", 
                0x02, 
                "TZ00 _TMP", 
                0x02, 
                "TZ01 _TMP"
            })
            Name (TSD2, Package (0x2C)
            {
                Zero, 
                "CPU Core 0 DTS", 
                Zero, 
                "CPU Core 1 DTS", 
                Zero, 
                "CPU Core 2 DTS", 
                Zero, 
                "CPU Core 3 DTS", 
                Zero, 
                "CPU Core Package DTS", 
                0x03, 
                "Memory Participant", 
                0x03, 
                "VR Hotspot Q50", 
                0x03, 
                "C-Skin Hotspot U50", 
                0x03, 
                "PMIC-MCP Hotspot Q16", 
                0x02, 
                "C-Skin Chassis U50 IR", 
                0x02, 
                "WWAN Hotspot Q6", 
                0x02, 
                "Ambient Hotspot U31", 
                Zero, 
                "CPU Package Temperature", 
                0x05, 
                "PCH DTS Temperature from PCH", 
                Zero, 
                "CPU PECI reading", 
                0x05, 
                "SA DTS Temperature from PCH", 
                0x02, 
                "TS-on-DIMM0 Temperature", 
                0x02, 
                "TS-on-DIMM1 Temperature", 
                0x02, 
                "TS-on-DIMM2 Temperature", 
                0x02, 
                "TS-on-DIMM3 Temperature", 
                0x02, 
                "TZ00 _TMP", 
                0x02, 
                "TZ01 _TMP"
            })
            Name (TSD3, Package (0x2C)
            {
                Zero, 
                "CPU Core 0 DTS", 
                Zero, 
                "CPU Core 1 DTS", 
                Zero, 
                "CPU Core 2 DTS", 
                Zero, 
                "CPU Core 3 DTS", 
                Zero, 
                "CPU Core Package DTS", 
                0x03, 
                "Sensor 1 Not used.", 
                0x03, 
                "SSD Board Temperature Sensor", 
                0x03, 
                "CPU VR Board Temperature Sensor", 
                0x03, 
                "WWAN Board Temperature Sensor", 
                0x02, 
                "Sensor 5 Not used.", 
                0x02, 
                "Memory Temperature Sensor", 
                0x02, 
                "Board Fan Inlet Temperature", 
                Zero, 
                "CPU Package Temperature", 
                0x05, 
                "PCH DTS Temperature from PCH", 
                Zero, 
                "CPU PECI reading", 
                0x05, 
                "SA DTS Temperature from PCH", 
                0x02, 
                "TS-on-DIMM0 Temperature", 
                0x02, 
                "TS-on-DIMM1 Temperature", 
                0x02, 
                "TS-on-DIMM2 Temperature", 
                0x02, 
                "TS-on-DIMM3 Temperature", 
                0x02, 
                "TZ00 _TMP", 
                0x02, 
                "TZ01 _TMP"
            })
            Name (TSD4, Package (0x2C)
            {
                Zero, 
                "CPU Core 0 DTS", 
                Zero, 
                "CPU Core 1 DTS", 
                Zero, 
                "CPU Core 2 DTS", 
                Zero, 
                "CPU Core 3 DTS", 
                Zero, 
                "CPU Core Package DTS", 
                0x03, 
                "Sensor 1 Not used.", 
                0x03, 
                "Sensor 2 Not used.", 
                0x03, 
                "CPU Board Sensor U8", 
                0x03, 
                "Sensor 4 Not used.", 
                0x02, 
                "CPU Skin U8 IR", 
                0x02, 
                "Sensor 6 Not used.", 
                0x02, 
                "Sensor 7 Not used.", 
                Zero, 
                "CPU Package Temperature", 
                0x05, 
                "PCH DTS Temperature from PCH", 
                Zero, 
                "CPU PECI reading", 
                0x05, 
                "SA DTS Temperature from PCH", 
                0x02, 
                "TS-on-DIMM0 Temperature", 
                0x02, 
                "TS-on-DIMM1 Temperature", 
                0x02, 
                "TS-on-DIMM2 Temperature", 
                0x02, 
                "TS-on-DIMM3 Temperature", 
                0x02, 
                "TZ00 _TMP", 
                0x02, 
                "TZ01 _TMP"
            })
            Name (TSD5, Package (0x22)
            {
                Zero, 
                "CPU Core 0 DTS", 
                Zero, 
                "CPU Core 1 DTS", 
                Zero, 
                "CPU Core 2 DTS", 
                Zero, 
                "CPU Core 3 DTS", 
                Zero, 
                "CPU Core Package DTS", 
                0x03, 
                "CPU Core VR (IMVP) Temperature", 
                0x03, 
                "Heat Exchanger Fan Temperature", 
                0x03, 
                "Skin Temperature", 
                0x03, 
                "Ambient Temperature", 
                0x02, 
                "Sensor 5 Not used.", 
                0x02, 
                "Channel 0 DIMM Temperature", 
                0x02, 
                "Channel 1 DIMM Temperature", 
                Zero, 
                "CPU Package Temperature", 
                Zero, 
                "CPU PECI reading", 
                0x05, 
                "SA DTS Temperature from PCH", 
                0x02, 
                "TZ00 _TMP", 
                0x02, 
                "TZ01 _TMP"
            })
            Name (PSDL, Package (0x26)
            {
                0x0B, 
                "Platform Power (mW)", 
                0x0B, 
                "Brick Power cW(100ths)", 
                0x0B, 
                "Battery Discharge Power cW(100ths)", 
                0x0B, 
                "Platform Average Power (mW)", 
                0x0B, 
                "Brick Average Power cW(0.01)", 
                0x0B, 
                "Battery Discharge Average Power cW(0.01)", 
                0x0C, 
                "Battery 1 Design Capacity (mWh)", 
                0x0C, 
                "Battery 1 Remaining Capacity (mWh)", 
                0x0C, 
                "Battery 1 Full Charge Capacity (mWh)", 
                0x0C, 
                "Battery 1 Full Resolution Voltage (mV)", 
                0x0C, 
                "Battery 1 Full Resolution Discharge Current (mA)", 
                0x0C, 
                "Battery 1 Full Resolution Charge Current (mA)", 
                0x0C, 
                "Battery 2 Remaining Capacity (mWh)", 
                0x0C, 
                "Battery 2 Full Charge Capacity (mWh)", 
                0x0C, 
                "Battery 2 Full Resolution Voltage (mV)", 
                0x0C, 
                "Battery 2 Full Resolution Discharge Current (mA)", 
                0x0C, 
                "Battery 2 Full Resolution Charge Current (mA)", 
                0x0C, 
                "Battery Pack 1 maximum power (mW)", 
                0x0C, 
                "Battery Pack 2 maximum power (mW)"
            })
            Method (OSDL, 0, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                While (One)
                {
                    Store (BID, _T_0)
                    If (LEqual (_T_0, 0x38))
                    {
                        Return (OSD4)
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x30))
                        {
                            Return (OSD3)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x31))
                            {
                                Return (OSD2)
                            }
                            Else
                            {
                                Return (OSD1)
                            }
                        }
                    }

                    Break
                }
            }

            Name (OSD1, Package (0x09)
            {
                0x04, 
                "CPU Fan Duty Cycle", 
                "RAW", 
                0x04, 
                "CPU Fan #1 Speed", 
                "RPM", 
                0x03, 
                "Skin Temp 0", 
                "RAW"
            })
            Name (OSD2, Package (0x1B)
            {
                0x04, 
                "CPU Fan Duty Cycle", 
                "RAW", 
                0x04, 
                "CPU Fan #1 Speed", 
                "RPM", 
                0x03, 
                "Skin Temp 0", 
                "RAW", 
                0x03, 
                "Thermistor 1 ", 
                "RAW", 
                0x03, 
                "Thermistor 2 ", 
                "RAW", 
                0x03, 
                "Thermistor 3 ", 
                "RAW", 
                0x03, 
                "Thermistor 4 ", 
                "RAW", 
                0x03, 
                "Thermistor 5 ", 
                "RAW", 
                0x03, 
                "Thermistor 6 ", 
                "RAW"
            })
            Name (OSD3, Package (0x1E)
            {
                0x04, 
                "CPU Fan Duty Cycle", 
                "RAW", 
                0x04, 
                "CPU Fan #1 Speed", 
                "RPM", 
                0x04, 
                "CPU Fan #2 Speed", 
                "RPM", 
                0x03, 
                "Skin Temp 0", 
                "RAW", 
                0x03, 
                "Thermistor 1 ", 
                "RAW", 
                0x03, 
                "Thermistor 2 ", 
                "RAW", 
                0x03, 
                "Thermistor 3 ", 
                "RAW", 
                0x03, 
                "Thermistor 4 ", 
                "RAW", 
                0x03, 
                "Thermistor 5 ", 
                "RAW", 
                0x03, 
                "Thermistor 6 ", 
                "RAW"
            })
            Name (OSD4, Package (0x0F)
            {
                0x03, 
                "Skin Temp 0", 
                "RAW", 
                0x03, 
                "Thermistor 3 ", 
                "RAW", 
                0x03, 
                "Thermistor 4 ", 
                "RAW", 
                0x03, 
                "Thermistor 5 ", 
                "RAW", 
                0x03, 
                "Thermistor 6 ", 
                "RAW"
            })
            Method (TSDD, 0, Serialized)
            {
                Name (_T_0, Zero)  // _T_x: Emitted by ASL Compiler
                While (One)
                {
                    Store (BID, _T_0)
                    If (LNotEqual (Match (Package (0x0A)
                                    {
                                        0x80, 
                                        0x83, 
                                        0x82, 
                                        0x20, 
                                        0x22, 
                                        0x27, 
                                        0x28, 
                                        0x24, 
                                        0x30, 
                                        0x31
                                    }, MEQ, _T_0, MTR, Zero, Zero), Ones))
                    {
                        Name (TULT, Package (0x11)
                        {
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000
                        })
                        Store (Add (Multiply (\_PR.DTS1, 0x0A), 0x0AAC), Index (TULT, 
                            Zero))
                        Store (Add (Multiply (\_PR.DTS2, 0x0A), 0x0AAC), Index (TULT, 
                            One))
                        Store (Add (Multiply (\_PR.DTS3, 0x0A), 0x0AAC), Index (TULT, 
                            0x02))
                        Store (Add (Multiply (\_PR.DTS4, 0x0A), 0x0AAC), Index (TULT, 
                            0x03))
                        Store (Add (Multiply (\_PR.PDTS, 0x0A), 0x0AAC), Index (TULT, 
                            0x04))
                        Store (\_TZ.TZ00._TMP, Index (TULT, 0x0F))
                        If (CondRefOf (\_TZ.TZ01))
                        {
                            Store (\_TZ.TZ01._TMP (), Index (TULT, 0x10))
                        }

                        Return (TULT)
                    }
                    Else
                    {
                        Name (TMPV, Package (0x16)
                        {
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000, 
                            0x80000000
                        })
                        Store (Add (Multiply (\_PR.DTS1, 0x0A), 0x0AAC), Index (TMPV, 
                            Zero))
                        Store (Add (Multiply (\_PR.DTS2, 0x0A), 0x0AAC), Index (TMPV, 
                            One))
                        Store (Add (Multiply (\_PR.DTS3, 0x0A), 0x0AAC), Index (TMPV, 
                            0x02))
                        Store (Add (Multiply (\_PR.DTS4, 0x0A), 0x0AAC), Index (TMPV, 
                            0x03))
                        Store (Add (Multiply (\_PR.PDTS, 0x0A), 0x0AAC), Index (TMPV, 
                            0x04))
                        Store (\_TZ.TZ00._TMP, Index (TMPV, 0x14))
                        If (CondRefOf (\_TZ.TZ01))
                        {
                            Store (\_TZ.TZ01._TMP (), Index (TMPV, 0x15))
                        }

                        Return (TMPV)
                    }

                    Break
                }
            }

            Method (PSDD, 0, Serialized)
            {
                Name (PWRV, Package (0x13)
                {
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000, 
                    0x80000000
                })
                Return (PWRV)
            }

            Method (OSDD, 0, Serialized)
            {
            }

            Method (SDSP, 0, NotSerialized)
            {
                Return (0x0A)
            }

            Name (PADA, Package (0x0A)
            {
                One, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0x1A, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF
            })
            Name (PADD, Package (0x0A)
            {
                0x02, 
                0x06A4, 
                0x06A0, 
                0x1A, 
                0x62, 
                0x63, 
                0x60, 
                0x61, 
                0x65, 
                0x64
            })
            Method (PADT, 0, NotSerialized)
            {
                If (PAMT)
                {
                    Return (PADA)
                }

                Return (PADD)
            }

            Method (RPMD, 0, Serialized)
            {
                Name (MTMP, Buffer (0x1A) {})
                Return (MTMP)
            }

            Method (WPMD, 1, NotSerialized)
            {
                If (LNotEqual (SizeOf (Arg0), 0x1A))
                {
                    Return (0xFFFFFFFF)
                }

                Return (Zero)
            }

            Method (ISPC, 0, NotSerialized)
            {
                Return (Zero)
            }

            Method (ENPC, 0, NotSerialized)
            {
                Return (Zero)
            }

            Method (RPCS, 0, NotSerialized)
            {
                Return (Zero)
            }

            Method (RPEC, 0, NotSerialized)
            {
                Store (Zero, Local0)
                Return (Local0)
            }
        }
    }
}

